'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	ENCODEBANK
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem		
Function EncodeBank:TBank ( SourceBank:TBank, Key:String )
	
	Local	SourceSize:Int 							=	SourceBank.Size ( )
	Local	DestinationBank:TBank						=	TBank.Create ( SourceSize )
	Local	Map:Byte [ SourceSize ]
	Local	MapPos:Int, Pos:Int

	SeedRnd ( _encodebank_keygen ( Key ) ~ SourceSize )
	
	While Pos < SourceSize	
	
		Repeat
		
			MapPos							=	Rand ( 0, SourceSize - 1 )
		
		Until Map [ MapPos ] = False
		
		Map [ MapPos ]							=	True
		
		DestinationBank.PokeByte ( Pos, SourceBank.PeekByte ( MapPos ) ~ Rand ( 0, 255 ) )
		
		Pos									:+	1
	
	Wend
	
	Return ( DestinationBank )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	DECODEBANK
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem		
Function DecodeBank:TBank ( SourceBank:TBank, Key:String )
	
	Local	SourceSize:Int 							=	SourceBank.Size ( )
	Local	DestinationBank:TBank						=	TBank.Create ( SourceSize )
	Local	Map:Byte [ SourceSize ]
	Local	MapPos:Int, Pos:Int
	
	SeedRnd ( _encodebank_keygen ( Key ) ~ SourceSize )
	
	While Pos < SourceSize	
	
		Repeat
		
			MapPos							=	Rand ( 0, SourceSize - 1 )
		
		Until Map [ MapPos ] = False

		Map [ MapPos ]							=	True
		
		DestinationBank.PokeByte ( MapPos, SourceBank.PeekByte ( Pos ) ~ Rand ( 0, 255 )  )

		Pos									:+	1
	
	Wend
	
	Return ( DestinationBank )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	DECODEBANK
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Function _encodebank_keygen:Int ( Key:String )

	Local	result:Int								=	317

	For Local i:Int = 0 Until Key.length
	
		result								:+	i
		result								:~	Key [ i ]
	
	Next
	
	Return ( result )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	FINISHED
'---------------------------------------------------------------------------------------------------------------------------------------------------------

