'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	FUNCTIONS
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
about:
End Rem
Function ListFirst:Object ( List:TList )
	
	If	list = Null

		Error "ListFirst : TList ist Null."
	
	EndIf
	
	If	ListIsEmpty ( list )
	
		Return ( Null )
		
	Else

		Return ( list.first() )

	EndIf
	
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
about:
End Rem
Function ListLast:Object ( List:TList )

	If	List = Null

		Error "ListFirst : TList ist Null."
	
	EndIf

	If	ListIsEmpty ( list )
	
		Return ( Null )
		
	Else

		Return ( list.last() )

	EndIf

EndFunction


'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:.
End Rem
Function ListAddAfter ( List:TList, AfterObject:Object, AddObject:Object )

	If	List = Null

		Error "ListAddAfter : TList ist Null."
	
	EndIf

	If	AfterObject = Null

		Error "ListAddAfter : AfterObject:TObject ist Null."
	
	EndIf

	If	AddObject = Null

		Error "ListAddAfter : AddObject:TObject ist Null."
	
	EndIf
		
	Local	link:TLink								=	list.findlink ( afterobject )
	
	If	link = Null

		Error "ListAddAfter : BeforeObject:TObject wurde in der Liste nicht gefunden."
	
	EndIf
		
	list.insertafterlink ( addobject, link )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:.
End Rem
Function ListAddBefore ( List:TList, AddObject:Object, BeforeObject:Object )

	If	List = Null

		Error "ListAddBefore : TList ist Null."
	
	EndIf

	If	BeforeObject = Null

		Error "ListAddBefore : BeforeObject:TObject ist Null."
	
	EndIf

	If	AddObject = Null

		Error "ListAddBefore : AddObject:TObject ist Null."
	
	EndIf	
	Local	link:TLink								=	list.findlink ( beforeobject )
	
	If	link = Null

		Error "ListAddBefore : BeforeObject:TObject wurde in der Liste nicht gefunden."
	
	EndIf
		
	list.insertbeforelink ( addobject, link )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:.
End Rem
Function ListAfter:Object ( list:TList, AfterObject:Object )

	If	List = Null

		Error "ListAfter : TList ist Null."
	
	EndIf

	If	AfterObject = Null

		Error "ListAfter : AfterObject:TObject ist Null."
	
	EndIf
	
	Local	link:TLink								=	list.findlink ( afterobject )
	
	If	link = Null

		Error "ListAddAfter : BeforeObject:TObject wurde in der Liste nicht gefunden."
	
	EndIf
	
	link										=	link._succ
	
	If	link
	
		Return ( link._value )
	
	Else
	
		Return ( Null )
	
	EndIf

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:.
End Rem
Function ListBefore:Object ( list:TList, BeforeObject:Object )

	If	List = Null

		Error "ListBefore : TList ist Null."
	
	EndIf

	If	BeforeObject = Null

		Error "ListBefore : BeforeObject:TObject ist Null."
	
	EndIf
	
	Local	link:TLink								=	list.findlink ( beforeobject )
	
	If	link = Null

		Error "ListBefore : BeforeObject:TObject wurde in der Liste nicht gefunden."
	
	EndIf
		
	link										=	link._pred
	
	If	link
	
		Return ( link._value )
	
	Else
	
		Return ( Null )
	
	EndIf

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
