'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Type TColor

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Global	ReferenceMap:TMap						=	CreateMap ( )

'---------------------------------------------------------------------------------------------------------------------------------------------------------
	
	Field		r:Float							=	1.00
	Field		g:Float							=	1.00
	Field		b:Float							=	1.00
	Field		a:Float							=	1.00

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	Set ( Relative:Byte )

			SetColor ( r, g, b, a, Relative )

	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	Push ( Relative:Byte )

			PushColor ( r, g, b, a, Relative )

	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

EndType

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function CreateColor:TColor ( r:Float, g:Float, b:Float, a:Float = 1.00 )
	
	Local	n:TColor								=	New TColor
		
		n.r									=	r
		n.g									=	g
		n.b									=	b
		n.a									=	a		

	Return ( n )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function CreateColorRef:TColor ( Name:String, r:Float, g:Float, b:Float, a:Float = 1.00 )
	
	Local	n:TColor								=	New TColor
		
		n.r									=	r
		n.g									=	g
		n.b									=	b
		n.a									=	a
		
		MapInsert ( TColor.ReferenceMap, Name, n )	

	Return ( n )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SetColorObject ( Color:TColor, Relative:Byte = False )
	
	If	Color = Null
	
		Error ( "SetColorObject : TColor ist Null." )
	
	EndIf

	Color.Set ( Relative )
	
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PushColorObject ( Color:TColor, Relative:Byte = False )
	
	If	Color = Null
	
		Error ( "PushColorObject : TColor ist Null." )
	
	EndIf

	Color.Push ( Relative )
	
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SetColorRef ( Name:String, Relative:Byte = False )
	
	Local	Color:TColor							=	TColor ( MapValueForKey ( TColor.ReferenceMap, Name ) )
	
	If	Color = Null
	
		Error ( "SetColorRef : Referenz ~q" + Name + "~q nicht vorhanden." )
	
	EndIf

	Color.Set ( Relative )
	
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PushColorRef ( Name:String, Relative:Byte = false )
	
	Local	Color:TColor							=	TColor ( MapValueForKey ( TColor.ReferenceMap, Name ) )
	
	If	Color = Null
	
		Error ( "PushColorRef : Referenz ~q" + Name + "~q nicht vorhanden." )
	
	EndIf

	Color.Push ( Relative )
	
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
