'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Global	_AVA_GFX_CLS_COLOR_R:TFloatStack					=	New TFloatStack
Global	_AVA_GFX_CLS_COLOR_G:TFloatStack					=	New TFloatStack
Global	_AVA_GFX_CLS_COLOR_B:TFloatStack					=	New TFloatStack
Global	_AVA_GFX_CLS_COLOR_A:TFloatStack					=	New TFloatStack

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SetClsColor ( r:Float, g:Float, b:Float, a:Float = 0.00 )

		_AVA_GFX_CLS_COLOR_R.Set ( r )
		_AVA_GFX_CLS_COLOR_G.Set ( g )
		_AVA_GFX_CLS_COLOR_B.Set ( b )
		_AVA_GFX_CLS_COLOR_A.Set ( a )
		
		_AVA_GFX_UPDATE_CLS_COLOR ( )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function ResetClsColor ( )

		_AVA_GFX_CLS_COLOR_R.Reset ( 0.00 )
		_AVA_GFX_CLS_COLOR_G.Reset ( 0.00 )
		_AVA_GFX_CLS_COLOR_B.Reset ( 0.00 )
		_AVA_GFX_CLS_COLOR_A.Reset ( 0.00 )
		
		_AVA_GFX_UPDATE_CLS_COLOR ( )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PushClsColor ( r:Float, g:Float, b:Float, a:Float = 0.00 )

		_AVA_GFX_CLS_COLOR_R.Push ( r )
		_AVA_GFX_CLS_COLOR_G.Push ( g )
		_AVA_GFX_CLS_COLOR_B.Push ( b )
		_AVA_GFX_CLS_COLOR_A.Push ( a )
		
		_AVA_GFX_UPDATE_CLS_COLOR ( )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PopClsColor ( )

		_AVA_GFX_CLS_COLOR_R.Pop ( )
		_AVA_GFX_CLS_COLOR_G.Pop ( )
		_AVA_GFX_CLS_COLOR_B.Pop ( )
		_AVA_GFX_CLS_COLOR_A.Pop ( )
		
		_AVA_GFX_UPDATE_CLS_COLOR ( )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function GetClsColor ( r:Float Var, g:Float Var, b:Float Var, a:Float Var )

		r									=	_AVA_GFX_CLS_COLOR_R.Get ( )
		g									=	_AVA_GFX_CLS_COLOR_G.Get ( )
		b									=	_AVA_GFX_CLS_COLOR_B.Get ( )
		a									=	_AVA_GFX_CLS_COLOR_A.Get ( )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Function	_AVA_GFX_UPDATE_CLS_COLOR ( )

		Local	r:Float, g:Float, b:Float, a:Float
		GetClsColor ( r, g, b, a )
		
		StopDraw ( )
		
		_AVA_GL_CLIENT._CLS_COLOR ( r, g, b, a )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

