'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Global	_AVA_GFX_COLOR_R:TFloatStack					=	New TFloatStack
Global	_AVA_GFX_COLOR_G:TFloatStack					=	New TFloatStack
Global	_AVA_GFX_COLOR_B:TFloatStack					=	New TFloatStack
Global	_AVA_GFX_COLOR_A:TFloatStack					=	New TFloatStack

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SetColor ( r:Float, g:Float, b:Float, a:Float = 1.00, relative:Byte = False )

		If	relative
		
			r								:*	_AVA_GFX_COLOR_R.Get ( )
			g								:*	_AVA_GFX_COLOR_G.Get ( )
			b								:*	_AVA_GFX_COLOR_B.Get ( )
			a								:*	_AVA_GFX_COLOR_A.Get ( )
		
		EndIf

		_AVA_GFX_COLOR_R.Set ( r )
		_AVA_GFX_COLOR_G.Set ( g )
		_AVA_GFX_COLOR_B.Set ( b )
		_AVA_GFX_COLOR_A.Set ( a )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function ResetColor ( )

		_AVA_GFX_COLOR_R.Reset ( 1.00 )
		_AVA_GFX_COLOR_G.Reset ( 1.00 )
		_AVA_GFX_COLOR_B.Reset ( 1.00 )
		_AVA_GFX_COLOR_A.Reset ( 1.00 )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PushColor ( r:Float, g:Float, b:Float, a:Float = 1.00, relative:Byte = False )
		
		If	relative
		
			r								:*	_AVA_GFX_COLOR_R.Get ( )
			g								:*	_AVA_GFX_COLOR_G.Get ( )
			b								:*	_AVA_GFX_COLOR_B.Get ( )
			a								:*	_AVA_GFX_COLOR_A.Get ( )
		
		EndIf
		
		_AVA_GFX_COLOR_R.Push ( r )
		_AVA_GFX_COLOR_G.Push ( g )
		_AVA_GFX_COLOR_B.Push ( b )
		_AVA_GFX_COLOR_A.Push ( a )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PopColor ( )

		_AVA_GFX_COLOR_R.Pop ( )
		_AVA_GFX_COLOR_G.Pop ( )
		_AVA_GFX_COLOR_B.Pop ( )
		_AVA_GFX_COLOR_A.Pop ( )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function GetColor ( r:Float Var, g:Float Var, b:Float Var, a:Float Var )

		r									=	_AVA_GFX_COLOR_R.Get ( )
		g									=	_AVA_GFX_COLOR_G.Get ( )
		b									=	_AVA_GFX_COLOR_B.Get ( )
		a									=	_AVA_GFX_COLOR_A.Get ( )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Function	_AVA_GFX_COLOR_TRANSFORM ( r:Float Var, g:Float Var, b:Float Var, a:Float Var )
		
		r									:*	_AVA_GFX_COLOR_R.Get ( )
		g									:*	_AVA_GFX_COLOR_G.Get ( )
		b									:*	_AVA_GFX_COLOR_B.Get ( )
		a									:*	_AVA_GFX_COLOR_A.Get ( )
		
		If	_AVA_GFX_COLOR_SCALE_USE
		
			r								:*	_AVA_GFX_COLOR_SCALE_R.Get ( )
			g								:*	_AVA_GFX_COLOR_SCALE_G.Get ( )
			b								:*	_AVA_GFX_COLOR_SCALE_B.Get ( )
			a								:*	_AVA_GFX_COLOR_SCALE_A.Get ( )
		
		EndIf

		If	_AVA_GFX_COLOR_OFFSET_USE
		
			r								:+	_AVA_GFX_COLOR_OFFSET_R.Get ( )
			g								:+	_AVA_GFX_COLOR_OFFSET_G.Get ( )
			b								:+	_AVA_GFX_COLOR_OFFSET_B.Get ( )
			a								:+	_AVA_GFX_COLOR_OFFSET_A.Get ( )
		
		EndIf
				
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
