'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Global	_AVA_GFX_DEPTH_TEST:TByteStack				=	New TByteStack
Global	_AVA_GFX_DEPTH_FUNC:TIntStack				=	New TIntStack

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SetDepthTest ( Enabled:Byte )
		
		If	_AVA_GFX_DEPTH_TEST.get ( ) <> ( Enabled <> False )
		
			_AVA_GFX_DEPTH_TEST.set ( Enabled <> False )
			_AVA_GFX_UPDATE_DEPTH_TEST ( )
		
		EndIf
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function ResetDepthTest ( )

		_AVA_GFX_DEPTH_TEST.push ( False )
		_AVA_GFX_UPDATE_DEPTH_TEST ( )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PushDepthTest ( Enabled:Byte )
		
		_AVA_GFX_DEPTH_TEST.push ( Enabled <> False )
		_AVA_GFX_UPDATE_DEPTH_TEST ( )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PopDepthTest ( )
		
		_AVA_GFX_DEPTH_TEST.pop ( )
		_AVA_GFX_UPDATE_DEPTH_TEST ( )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SetDepthFunc ( func:Int )
		
		If	_AVA_GFX_DEPTH_FUNC.Get ( ) <> func
		
			_AVA_GFX_DEPTH_FUNC.Set ( func )
			_AVA_GFX_UPDATE_DEPTH_FUNC ( )

		EndIf
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function ResetDepthFunc ( )

		_AVA_GFX_DEPTH_FUNC.Reset ( GL_ALWAYS )
		_AVA_GFX_UPDATE_DEPTH_FUNC ( )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PushDepthFunc ( func:Int )

		_AVA_GFX_DEPTH_FUNC.Push ( func )
		_AVA_GFX_UPDATE_DEPTH_FUNC ( )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PopDepthFunc ( )

		_AVA_GFX_DEPTH_FUNC.Pop ( )
		_AVA_GFX_UPDATE_DEPTH_FUNC ( )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Function	_AVA_GFX_UPDATE_DEPTH_TEST ( )
		
		StopDraw ( )
		
		If	_AVA_GFX_DEPTH_TEST.get ( )
		
			_AVA_GL_CLIENT._ENABLE ( GL_DEPTH_TEST )
		
		Else
		
			_AVA_GL_CLIENT._DISABLE ( GL_DEPTH_TEST )
		
		EndIf

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Function	_AVA_GFX_UPDATE_DEPTH_FUNC ( )

		StopDraw ( )

		_AVA_GL_CLIENT._DEPTH_FUNC ( _AVA_GFX_DEPTH_FUNC.Get ( ) )

		CheckGLError ( )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

