'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Global	_AVA_GFX_DEPTH_NEAR:TFloatStack				=	New TFloatStack
Global	_AVA_GFX_DEPTH_FAR:TFloatStack				=	New TFloatStack

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SetDepthRange ( Near:Float, Far:Float, relative:Byte = False )

		If	relative

			Near								:+	_AVA_GFX_DEPTH_NEAR.Get ( )
			Far								:+	_AVA_GFX_DEPTH_FAR.Get ( )
		
		EndIf
		
		_AVA_GFX_DEPTH_NEAR.Set ( Near )
		_AVA_GFX_DEPTH_FAR.Set ( Far )

		_AVA_GFX_UPDATE_DEPTH_RANGE ( )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function ResetDepthRange ( )

		_AVA_GFX_DEPTH_NEAR.Reset ( -1.00 )
		_AVA_GFX_DEPTH_FAR.Reset ( 1.00 )
		
		_AVA_GFX_UPDATE_DEPTH_RANGE ( )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PushDepthRange ( Near:Float, Far:Float, relative:Byte = False )

		If	relative

			Near								:+	_AVA_GFX_DEPTH_NEAR.Get ( )
			Far								:+	_AVA_GFX_DEPTH_FAR.Get ( )
		
		EndIf

		_AVA_GFX_DEPTH_NEAR.Push ( Near )
		_AVA_GFX_DEPTH_FAR.Push ( Far )
		
		_AVA_GFX_UPDATE_DEPTH_RANGE ( )	
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PopDepthRange ( )

		_AVA_GFX_DEPTH_NEAR.Pop ( )
		_AVA_GFX_DEPTH_FAR.Pop ( )		
		
		_AVA_GFX_UPDATE_DEPTH_RANGE ( )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function DepthRangeNear:Float ( )

	Return ( _AVA_GFX_DEPTH_NEAR.Get ( ) )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function DepthRangeFar:Float ( )

	Return ( _AVA_GFX_DEPTH_FAR.Get ( ) )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Function	_AVA_GFX_UPDATE_DEPTH_RANGE ( )

		StopDraw ( )

		_AVA_GL_CLIENT._DEPTH_RANGE ( _AVA_GFX_DEPTH_NEAR.Get ( ), _AVA_GFX_DEPTH_FAR.Get ( ) )

		CheckGLError ( )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
