'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Global	_AVA_GFX_DISPLAY_WIDTH:TIntStack				=	New TIntStack
Global	_AVA_GFX_DISPLAY_HEIGHT:TIntStack				=	New TIntStack
Global	_AVA_GFX_DISPLAY_WFACTOR:Float				=	1.00
Global	_AVA_GFX_DISPLAY_HFACTOR:Float				=	1.00

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SetDisplay ( Width:Int, Height:Int )

		_AVA_GFX_DISPLAY_WIDTH.Set ( Width )
		_AVA_GFX_DISPLAY_HEIGHT.Set ( Height )
		_AVA_GFX_UPDATE_DISPLAY ( )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function ResetDisplay ( )

		_AVA_GFX_DISPLAY_WIDTH.Reset ( GraphicsWidth ( ) )
		_AVA_GFX_DISPLAY_HEIGHT.Reset ( GraphicsHeight ( ) )
		_AVA_GFX_UPDATE_DISPLAY ( )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PushDisplay ( Width:Int, Height:Int )

		_AVA_GFX_DISPLAY_WIDTH.Push ( Width )
		_AVA_GFX_DISPLAY_HEIGHT.Push ( Height )
		_AVA_GFX_UPDATE_DISPLAY ( )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PopDisplay (  )

		_AVA_GFX_DISPLAY_WIDTH.Pop ( )
		_AVA_GFX_DISPLAY_HEIGHT.Pop ( )
		_AVA_GFX_UPDATE_DISPLAY ( )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function GetDisplay ( Width:Int Var, Height:Int Var )

		Width									=	_AVA_GFX_DISPLAY_WIDTH.Get ( )
		Height								=	_AVA_GFX_DISPLAY_HEIGHT.Get ( )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function DisplayWidth:Int ( )

		Return ( _AVA_GFX_DISPLAY_WIDTH.Get ( ) )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function DisplayHeight:Int ( )

		Return ( _AVA_GFX_DISPLAY_HEIGHT.Get ( ) )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Function	_AVA_GFX_UPDATE_DISPLAY ( )
		
		_AVA_GFX_DISPLAY_WFACTOR					=	Float ( _AVA_GFX_DISPLAY_WIDTH.Get ( ) ) / Float ( GraphicsWidth ( ) )
		_AVA_GFX_DISPLAY_HFACTOR					=	Float ( _AVA_GFX_DISPLAY_HEIGHT.Get ( ) ) / Float ( GraphicsHeight ( ) )	
		
		StopDraw ( )
		
		If	_AVA_GFX_ACTIVE_BUFFER
				
			_AVA_GL_CLIENT._ORTHO ( 0, _AVA_GFX_DISPLAY_WIDTH.Get ( ), 0, _AVA_GFX_DISPLAY_HEIGHT.Get ( ) )
				
		Else
				
			_AVA_GL_CLIENT._ORTHO ( 0, _AVA_GFX_DISPLAY_WIDTH.Get ( ), _AVA_GFX_DISPLAY_HEIGHT.Get ( ), 0 )
		
		EndIf		
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

