'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	TYPE
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc: Die Objektklasse fr die Grafikengine.
End Rem
Type TAvaGraphicsEngine

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	GLOBALS
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Global	active_engine:TAvaGraphicsEngine			=	Null

'---------------------------------------------------------------------------------------------------------------------------------------------------------
	
	Global	debug ( Text:String )					=	DebugLog
	
	Global	GL_EXT:String						=	""
	Global	GL_FBO_AVAIL:Byte						=	False
	Global	GL_MULTITEX_AVAIL:Byte					=	False
	Global	GL_MULTITEX_UNITS:Int					=	0
	Global	GL_SHADERS_AVAIL:Byte					=	False
	Global	GL_VERT_SHADERS_AVAIL:Byte				=	False
	Global	GL_FRAG_SHADERS_AVAIL:Byte				=	False
	Global	GL_IMAGING_AVAIL:Byte					=	False

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	METHODS
'---------------------------------------------------------------------------------------------------------------------------------------------------------
	
	Method	New ( )
	
	Local		avail:String [ ]						=	[ "NICHT verfgbar", "verfgbar" ]
			
			active_engine						=	Self
						
			debug									( "" )
			debug									( "	[ AVA.GFX : initialisiere ENGINE ]" )
			debug									( "	[ AVA.GFX : initialisiere GLEW ]" )
			
			GLEWINIT ( )

			debug									( "	[ AVA.GFX : GLEW = erfolgreich ]" )
			debug									( "	[ AVA.GFX : lade GL_EXTENSIONS ]" )

			GL_EXT							=	Upper ( String.FromCString ( Byte Ptr ( glGetString ( GL_EXTENSIONS ) ) ) )
			
			If	GL_EXT <> ""
			
				debug								( "	[ AVA.GFX : GL_EXTENSIONS = erfolgreich ]" )

				GL_FBO_AVAIL					=	GL_EXT . find ( "GL_EXT_FRAMEBUFFER_OBJECT" ) > 0
				GL_MULTITEX_AVAIL					=	GL_EXT . find ( "GL_ARB_MULTITEXTURE" ) > 0 
				GL_SHADERS_AVAIL					=	GL_EXT . find ( "GL_ARB_SHADER_OBJECTS" ) > 0 And GL_EXT . find ( "GL_ARB_SHADING_LANGUAGE_100" ) > 0
				GL_VERT_SHADERS_AVAIL				=	GL_EXT . find ( "GL_ARB_VERTEX_SHADER" ) > 0
				GL_FRAG_SHADERS_AVAIL				=	GL_EXT . find ( "GL_ARB_FRAGMENT_SHADER" ) > 0
				GL_IMAGING_AVAIL					=	GL_EXT . find ( "GL_ARB_IMAGING" ) > 0
				
				glGetIntegerV						GL_MAX_TEXTURE_UNITS, Varptr GL_MULTITEX_UNITS
			
			?debug	
			
				debug								( "		[ GL_EXT : FRAMEBUFFERS = " + avail [ GL_FBO_AVAIL ] + " ]" )
				
				If	GL_MULTITEX_AVAIL
				
					debug							( "		[ GL_EXT : MULTITEXTURING = " + avail [ GL_MULTITEX_AVAIL ] + " ] [ " + GL_MULTITEX_UNITS + " Units ] " ) ' + "[ " + GL_MAX_GENERAL_COMBINERS_NV + " Combiners ] " )
				
				Else
				
					debug							( "		[ GL_EXT : MULTITEXTURING = " + avail [ GL_MULTITEX_AVAIL ] + " ]" )				
				
				EndIf
				
				debug								( "		[ GL_EXT : SHADERS = " + avail [ GL_SHADERS_AVAIL ] + " ]" )
				debug								( "		[ GL_EXT : VERTEX SHADERS = " + avail [ GL_VERT_SHADERS_AVAIL ] + " ]" )
				debug								( "		[ GL_EXT : FRAGMENT SHADERS = " + avail [ GL_FRAG_SHADERS_AVAIL ] + " ]" )
				debug								( "		[ GL_EXT : IMAGING = " + avail [ GL_IMAGING_AVAIL ] + " ]" )

				debug								( "	[ AVA.GFX : ENGINE = erfolgreich ]" )
			
			?
			
			Else
			
				debug								( "	WARNUNG : [ AVA.GFX : GL_EXTENSIONS = NICHT erfolgreich ]" )
				
				CheckGLError ( )
				
				Error								( "	WARNUNG : [ AVA.GFX : ENGINE = NICHT erfolgreich ]" )

			EndIf

	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	ENDTYPE
'---------------------------------------------------------------------------------------------------------------------------------------------------------

EndType

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------



