'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Global	_AVA_GFX_HANDLE_X:TFloatStack				=	New TFloatStack
Global	_AVA_GFX_HANDLE_Y:TFloatStack				=	New TFloatStack
Global	_AVA_GFX_HANDLE_Z:TFloatStack				=	New TFloatStack

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SetHandle ( x:Float, y:Float, z:Float = 0.00, relative:Byte = False )

		If	relative
			
			x								:+	_AVA_GFX_HANDLE_X.Get ( )
			y								:+	_AVA_GFX_HANDLE_Y.Get ( )
			z								:+	_AVA_GFX_HANDLE_Z.Get ( )
		
		EndIf
		
		_AVA_GFX_HANDLE_X.Set ( x )
		_AVA_GFX_HANDLE_Y.Set ( y )
		_AVA_GFX_HANDLE_Z.Set ( z )
		
		_AVA_GFX_TRANSFORM_MODIFIED					:|	_AVA_GFX_TRANSFORM_HANDLE_MODIFIED

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function ResetHandle ( )

		_AVA_GFX_HANDLE_X.Reset ( 0.00 )
		_AVA_GFX_HANDLE_Y.Reset ( 0.00 )
		_AVA_GFX_HANDLE_Z.Reset ( 0.00 )
		
		_AVA_GFX_TRANSFORM_MODIFIED					:|	_AVA_GFX_TRANSFORM_HANDLE_MODIFIED

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PushHandle ( x:Float, y:Float, z:Float = 0.00, relative:Byte = False )

		If	relative
			
			x								:+	_AVA_GFX_HANDLE_X.Get ( )
			y								:+	_AVA_GFX_HANDLE_Y.Get ( )
			z								:+	_AVA_GFX_HANDLE_Z.Get ( )
		
		EndIf

		_AVA_GFX_HANDLE_X.Push ( x )
		_AVA_GFX_HANDLE_Y.Push ( y )
		_AVA_GFX_HANDLE_Z.Push ( z )

		_AVA_GFX_TRANSFORM_MODIFIED					:|	_AVA_GFX_TRANSFORM_HANDLE_MODIFIED

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PopHandle ( )

		_AVA_GFX_HANDLE_X.Pop ( )
		_AVA_GFX_HANDLE_Y.Pop ( )
		_AVA_GFX_HANDLE_Z.Pop ( )

		_AVA_GFX_TRANSFORM_MODIFIED					:|	_AVA_GFX_TRANSFORM_HANDLE_MODIFIED

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

