'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	SETUP
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	RegisterMediaLoader ( New TMediaImageLoader, [ "PNG", "JPG", "BMP" ] )

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	TYPE
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Type TMediaImageLoader Extends TMediaLoader

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	METHODS
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	LoadFile ( Index:Int )

			MapInsert ( MediaMap, Handle [ Index ], LoadImage ( File [ Index ], Flags [ Index ], FloatValues [ Index ] [ 0 ], FloatValues [ Index ] [ 1 ] ) )
	
	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	FINISHED
'---------------------------------------------------------------------------------------------------------------------------------------------------------

EndType

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	EXTERNAL FUNCTIONS
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function AddMediaImage ( Handle:String, File:String, Flags:Int = -1, Handle_X:Float = 0.00, Handle_Y:Float = 0.00 )

		AddMedia ( Handle, File, Flags, "", [ Handle_X, Handle_Y ] )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function GetMediaImage:TImage ( Handle:String )
		
		Local	n:TImage							=	TImage ( GetMedia ( Handle ) )
		
		If	n = Null
		
			Error ( "GetMediaImage : TImage ~q" + Handle + "~q existiert nicht." )
		
		EndIf
		
		Return ( n )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

