'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Global	_AVA_GFX_BUFFER:TObjectStack				=	New TObjectStack
Global	_AVA_GFX_BUFFER_LIST:TList				=	CreateList ( )
Global	_AVA_GFX_ACTIVE_BUFFER:TImage			=	Null
Global	_AVA_GFX_LAST_ACTIVE_BUFFER:TImage			=	Null

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SetBuffer ( n:TImage )

		_AVA_GFX_BUFFER.Set ( n )		
		_AVA_GFX_ACTIVE_BUFFER					=	n
		_AVA_GFX_UPDATE_BUFFER ( )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PushBuffer ( n:TImage )

		_AVA_GFX_BUFFER.Push ( n )
		_AVA_GFX_ACTIVE_BUFFER					=	n
		_AVA_GFX_UPDATE_BUFFER ( )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PopBuffer ( )

		_AVA_GFX_BUFFER.Pop ( )
		_AVA_GFX_ACTIVE_BUFFER					=	TImage ( _AVA_GFX_BUFFER.Get ( ) )
		_AVA_GFX_UPDATE_BUFFER ( )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function GetBuffer:TImage ( )

		Return ( _AVA_GFX_ACTIVE_BUFFER )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function BufferWidth:Int ( )

		If	_AVA_GFX_ACTIVE_BUFFER
		
			Return ( _AVA_GFX_ACTIVE_BUFFER.width )
		
		Else
		
			Return ( GraphicsWidth ( ) )
		
		EndIf

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function BufferHeight:Int ( )

		If	_AVA_GFX_ACTIVE_BUFFER
		
			Return ( _AVA_GFX_ACTIVE_BUFFER.height )
		
		Else
		
			Return ( GraphicsHeight ( ) )
		
		EndIf

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Function	_AVA_GFX_UPDATE_BUFFER ( )

		If	TAvaGraphicsEngine . GL_FBO_AVAIL
				
			If	_AVA_GFX_ACTIVE_BUFFER <> _AVA_GFX_LAST_ACTIVE_BUFFER
						
				StopDraw ( )
			
				If	_AVA_GFX_LAST_ACTIVE_BUFFER
				
					PopDisplay ( )
				
				EndIf
				
				_AVA_GFX_LAST_ACTIVE_BUFFER				=	_AVA_GFX_ACTIVE_BUFFER
		
				If	_AVA_GFX_ACTIVE_BUFFER
					
					_AVA_GL_CLIENT._BIND_FRAMEBUFFER ( _AVA_GFX_ACTIVE_BUFFER.Buffer ( ) )
	
					PushDisplay ( BufferWidth ( ), BufferHeight ( ) )
		
				Else
						
					_AVA_GL_CLIENT._BIND_FRAMEBUFFER ( 0 )
				
				EndIf
		
				glViewport ( 0, 0, BufferWidth ( ), BufferHeight ( ) )
			
				CheckGLError ( )
	
			EndIf

		Else
		
			Error ( "Keine FrameBuffer Objekte verfgbar." )
		
		EndIf
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Function	_AVA_GFX_RELEASE_BUFFER ( )

		' !_TO_DO_!		

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
