'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Global	_AVA_GFX_ORIGIN_X:TFloatStack				=	New TFloatStack
Global	_AVA_GFX_ORIGIN_Y:TFloatStack				=	New TFloatStack
Global	_AVA_GFX_ORIGIN_Z:TFloatStack				=	New TFloatStack

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SetOrigin ( x:Float, y:Float, z:Float = 0.00, relative:Byte = False )

		If	relative
			
			x								:+	_AVA_GFX_ORIGIN_X.Get ( )
			y								:+	_AVA_GFX_ORIGIN_Y.Get ( )
			z								:+	_AVA_GFX_ORIGIN_Z.Get ( )
		
		EndIf
		
		_AVA_GFX_ORIGIN_X.Set ( x )
		_AVA_GFX_ORIGIN_Y.Set ( y )
		_AVA_GFX_ORIGIN_Z.Set ( z )
		
		_AVA_GFX_TRANSFORM_MODIFIED					:|	_AVA_GFX_TRANSFORM_ORIGIN_MODIFIED

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function ResetOrigin ( )

		_AVA_GFX_ORIGIN_X.Reset ( 0.00 )
		_AVA_GFX_ORIGIN_Y.Reset ( 0.00 )
		_AVA_GFX_ORIGIN_Z.Reset ( 0.00 )
		
		_AVA_GFX_TRANSFORM_MODIFIED					:|	_AVA_GFX_TRANSFORM_ORIGIN_MODIFIED

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PushOrigin ( x:Float, y:Float, z:Float = 0.00, relative:Byte = False )

		If	relative
			
			x								:+	_AVA_GFX_ORIGIN_X.Get ( )
			y								:+	_AVA_GFX_ORIGIN_Y.Get ( )
			z								:+	_AVA_GFX_ORIGIN_Z.Get ( )
		
		EndIf

		_AVA_GFX_ORIGIN_X.Push ( x )
		_AVA_GFX_ORIGIN_Y.Push ( y )
		_AVA_GFX_ORIGIN_Z.Push ( z )

		_AVA_GFX_TRANSFORM_MODIFIED					:|	_AVA_GFX_TRANSFORM_ORIGIN_MODIFIED

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PopOrigin ( )

		_AVA_GFX_ORIGIN_X.Pop ( )
		_AVA_GFX_ORIGIN_Y.Pop ( )
		_AVA_GFX_ORIGIN_Z.Pop ( )

		_AVA_GFX_TRANSFORM_MODIFIED					:|	_AVA_GFX_TRANSFORM_ORIGIN_MODIFIED

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function GetOrigin ( x:Float Var, y:Float Var, z:Float Var )

		x									=	_AVA_GFX_ORIGIN_X.Get ( )
		y									=	_AVA_GFX_ORIGIN_Y.Get ( )
		z									=	_AVA_GFX_ORIGIN_Z.Get ( )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function OriginX:Float ( )

		Return ( _AVA_GFX_ORIGIN_X.Get ( ) )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function OriginY:Float ( )

		Return ( _AVA_GFX_ORIGIN_Y.Get ( ) )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function OriginZ:Float ( )

		Return ( _AVA_GFX_ORIGIN_Z.Get ( ) )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

