'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Global	_AVA_GFX_ROTATION:TFloatStack				=	New TFloatStack
Global	_AVA_GFX_ROTATION_COS:TFloatStack				=	New TFloatStack
Global	_AVA_GFX_ROTATION_SIN:TFloatStack				=	New TFloatStack

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SetRotation ( a:Float, relative:Byte = False )

		If	relative
			
			a								:+	_AVA_GFX_ROTATION.Get ( )
	
		EndIf
		
		If	a <> _AVA_GFX_ROTATION.Get ( )
		
			_AVA_GFX_ROTATION.Set ( a )
			_AVA_GFX_ROTATION_COS.Set ( Cos ( a ) )
			_AVA_GFX_ROTATION_SIN.Set ( Sin ( a ) )		

			_AVA_GFX_TRANSFORM_MODIFIED				:|	_AVA_GFX_TRANSFORM_ROTATION_MODIFIED
		
		EndIf
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function ResetRotation( )

		_AVA_GFX_ROTATION.Set ( 0.00 )
		_AVA_GFX_ROTATION_COS.Set ( 1.00 )
		_AVA_GFX_ROTATION_SIN.Set ( 0.00 )		

		_AVA_GFX_TRANSFORM_MODIFIED					:|	_AVA_GFX_TRANSFORM_ROTATION_MODIFIED
			
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PushRotation ( a:Float, relative:Byte = False )

		If	relative
			
			a								:+	_AVA_GFX_ROTATION.Get ( )
	
		EndIf

		_AVA_GFX_ROTATION.Push ( a )
		_AVA_GFX_ROTATION_COS.Push ( Cos ( a ) )
		_AVA_GFX_ROTATION_SIN.Push ( Sin ( a ) )		

		_AVA_GFX_TRANSFORM_MODIFIED					:|	_AVA_GFX_TRANSFORM_ROTATION_MODIFIED
	
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PopRotation ( )

		_AVA_GFX_ROTATION.Pop ( )
		_AVA_GFX_ROTATION_COS.Pop ( )
		_AVA_GFX_ROTATION_SIN.Pop ( )	

		_AVA_GFX_TRANSFORM_MODIFIED					:|	_AVA_GFX_TRANSFORM_ROTATION_MODIFIED
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

