'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Global	_AVA_GFX_SCALE_X:TFloatStack					=	New TFloatStack
Global	_AVA_GFX_SCALE_Y:TFloatStack					=	New TFloatStack
Global	_AVA_GFX_SCALE_Z:TFloatStack					=	New TFloatStack

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SetScale ( x:Float, y:Float, z:Float = 1.00, relative:Byte = False )
		
		If	relative
			
			x								:*	_AVA_GFX_SCALE_X.Get ( )
			y								:*	_AVA_GFX_SCALE_Y.Get ( )
			z								:*	_AVA_GFX_SCALE_Z.Get ( )
		
		EndIf
		
		_AVA_GFX_SCALE_X.Set ( x )
		_AVA_GFX_SCALE_Y.Set ( y )
		_AVA_GFX_SCALE_Z.Set ( z )

		_AVA_GFX_TRANSFORM_MODIFIED					:|	_AVA_GFX_TRANSFORM_SCALE_MODIFIED

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function ResetScale ( )

		_AVA_GFX_SCALE_X.Reset ( 1.00 )
		_AVA_GFX_SCALE_Y.Reset ( 1.00 )
		_AVA_GFX_SCALE_Z.Reset ( 1.00 )
		
		_AVA_GFX_TRANSFORM_MODIFIED					:|	_AVA_GFX_TRANSFORM_SCALE_MODIFIED

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PushScale ( x:Float, y:Float, z:Float = 1.00, relative:Byte = False )

		If	relative
			
			x								:*	_AVA_GFX_SCALE_X.Get ( )
			y								:*	_AVA_GFX_SCALE_Y.Get ( )
			z								:*	_AVA_GFX_SCALE_Z.Get ( )
		
		EndIf

		_AVA_GFX_SCALE_X.Push ( x )
		_AVA_GFX_SCALE_Y.Push ( y )
		_AVA_GFX_SCALE_Z.Push ( z )

		_AVA_GFX_TRANSFORM_MODIFIED					:|	_AVA_GFX_TRANSFORM_SCALE_MODIFIED

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PopScale ( )

		_AVA_GFX_SCALE_X.Pop ( )
		_AVA_GFX_SCALE_Y.Pop ( )
		_AVA_GFX_SCALE_Z.Pop ( )

		_AVA_GFX_TRANSFORM_MODIFIED					:|	_AVA_GFX_TRANSFORM_SCALE_MODIFIED

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function GetScale ( x:Float Var, y:Float Var, z:Float Var )

		x									=	_AVA_GFX_SCALE_X.Get ( )
		y									=	_AVA_GFX_SCALE_Y.Get ( )
		z									=	_AVA_GFX_SCALE_Z.Get ( )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function ScaleX:Float ( )

		Return ( _AVA_GFX_SCALE_X.Get ( ) )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function ScaleY:Float ( )

		Return ( _AVA_GFX_SCALE_Y.Get ( ) )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function ScaleZ:Float ( )

		Return ( _AVA_GFX_SCALE_Z.Get ( ) )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
