'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function LoadSprite:TSprite ( URL:Object, Flags:Int = -1 )

		Local	Bank:TBank							=	LoadBank ( URL )
	
			If	bank = Null
			
				Error ( "LoadSprte : Datei ~q" + URL.toString ( ) + "~q konnte nicht geffnet werden." )
			
			EndIf
			
			Bank								=	UncompressBank ( Bank )
		
		Local	Stream:TStream						=	CreateBankStream ( Bank )
		Local	n:TSprite							=	TSprite.From_Stream ( Stream, Flags )

			CloseStream ( Stream )
		
		Return ( n )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SaveSprite ( Sprite:TSprite, URL:Object, Flags:Int = -1 )

		If	Sprite = Null
			
			Error ( "LoadSprte : TSprite ist Null." )
			
		EndIf
			
		Local	Bank:TBank							=	New TBank
		Local	Stream:TStream						=	CreateBankStream ( Bank )
		
		Sprite.To_Stream ( Stream )
		CloseStream ( Stream )

		SaveBank ( CompressBank ( Bank ), URL )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function DrawSprite ( Sprite:TSprite, Frame:Int = 0 )

		If	Sprite = Null
			
			Error ( "DrawSprite : TSprite ist Null." )
			
		EndIf
			
		While	Frame < 0
		
			Frame								:+	Sprite.Image.Length
		
		Wend
		
		Sprite.Frame							=	Frame Mod Sprite.Image.Length
		
		Sprite.Draw ( )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function CopySprite:TSprite ( Sprite:TSprite )

		If	Sprite = Null
			
			Error ( "CopySprte : TSprite ist Null." )
			
		EndIf
			
		Return ( Sprite.Copy ( ) )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

