'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Global	_AVA_GFX_UVHANDLE_X:TFloatStack				=	New TFloatStack
Global	_AVA_GFX_UVHANDLE_Y:TFloatStack				=	New TFloatStack

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SetUVHandle ( x:Float, y:Float, relative:Byte = False )

		If	relative
			
			x								:+	_AVA_GFX_UVHANDLE_X.Get ( )
			y								:+	_AVA_GFX_UVHANDLE_Y.Get ( )
		
		EndIf
		
		_AVA_GFX_UVHANDLE_X.Set ( x )
		_AVA_GFX_UVHANDLE_Y.Set ( y )
		
		_AVA_GFX_UVTRANSFORM_MODIFIED				:|	_AVA_GFX_UVTRANSFORM_UVHANDLE_MODIFIED

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function ResetUVHandle ( )

		_AVA_GFX_UVHANDLE_X.Reset ( 0.00 )
		_AVA_GFX_UVHANDLE_Y.Reset ( 0.00 )
		
		_AVA_GFX_UVTRANSFORM_MODIFIED				:|	_AVA_GFX_UVTRANSFORM_UVHANDLE_MODIFIED

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PushUVHandle ( x:Float, y:Float, relative:Byte = False )

		If	relative
			
			x								:+	_AVA_GFX_UVHANDLE_X.Get ( )
			y								:+	_AVA_GFX_UVHANDLE_Y.Get ( )
	
		EndIf

		_AVA_GFX_UVHANDLE_X.Push ( x )
		_AVA_GFX_UVHANDLE_Y.Push ( y )

		_AVA_GFX_UVTRANSFORM_MODIFIED				:|	_AVA_GFX_UVTRANSFORM_UVHANDLE_MODIFIED

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PopUVHandle ( )

		_AVA_GFX_UVHANDLE_X.Pop ( )
		_AVA_GFX_UVHANDLE_Y.Pop ( )

		_AVA_GFX_UVTRANSFORM_MODIFIED				:|	_AVA_GFX_UVTRANSFORM_UVHANDLE_MODIFIED

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

