'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Global	_AVA_GFX_UVOFFSET_X:TFloatStack				=	New TFloatStack
Global	_AVA_GFX_UVOFFSET_Y:TFloatStack				=	New TFloatStack

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SetUVOffset ( x:Float, y:Float, relative:Byte = False )

		If	relative
			
			x								:+	_AVA_GFX_UVOFFSET_X.Get ( )
			y								:+	_AVA_GFX_UVOFFSET_Y.Get ( )
		
		EndIf

		_AVA_GFX_UVOFFSET_X.Set ( x )
		_AVA_GFX_UVOFFSET_Y.Set ( y )

		_AVA_GFX_UVTRANSFORM_MODIFIED				:|	_AVA_GFX_UVTRANSFORM_UVOFFSET_MODIFIED

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function ResetUVOffset ( )

		_AVA_GFX_UVOFFSET_X.Reset ( 0.00 )
		_AVA_GFX_UVOFFSET_Y.Reset ( 0.00 )
		
		_AVA_GFX_UVTRANSFORM_MODIFIED				:|	_AVA_GFX_UVTRANSFORM_UVOFFSET_MODIFIED

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PushUVOffset ( x:Float, y:Float, relative:Byte = False )

		If	relative
			
			x								:+	_AVA_GFX_UVOFFSET_X.Get ( )
			y								:+	_AVA_GFX_UVOFFSET_Y.Get ( )
		
		EndIf

		_AVA_GFX_UVOFFSET_X.Push ( x )
		_AVA_GFX_UVOFFSET_Y.Push ( y )

		_AVA_GFX_UVTRANSFORM_MODIFIED				:|	_AVA_GFX_UVTRANSFORM_UVOFFSET_MODIFIED

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PopUVOffset ( )

		_AVA_GFX_UVOFFSET_X.Pop ( )
		_AVA_GFX_UVOFFSET_Y.Pop ( )

		_AVA_GFX_UVTRANSFORM_MODIFIED				:|	_AVA_GFX_UVTRANSFORM_UVOFFSET_MODIFIED

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

