'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	MODULE
'---------------------------------------------------------------------------------------------------------------------------------------------------------

SuperStrict

Rem
bbdoc: AVA.GL
End Rem
Module AVA.GL

ModuleInfo	"Version: 1.10"
ModuleInfo	"Authors: Ava Vanessa Poldrack"
ModuleInfo	"Copyright: Ava Vanessa Poldrack"

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	IMPORTS
'---------------------------------------------------------------------------------------------------------------------------------------------------------
	
Import AVA.Core

Import PUB.OpenGL
Import PUB.Glew

'---------------------------------------------------------------------------------------------------------------------------------------------------------

?Win32
Import	"avagraphics.win32.c"
?MacOS
Import	"avagraphics.macos.m"
?Linux
Import	"..\..\brl.mod\glgraphics.mod\-lX11"
Import	"..\..\brl.mod\glgraphics.mod\-lXxf86vm"
Import	"..\..\brl.mod\glgraphics.mod\-lGL"
Import	"avagraphics.linux.c"
?

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	EXTERN
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Extern
		Function bbGLGraphicsGraphicsModes ( buf:Byte Ptr, size:Int )
		Function bbGLGraphicsAttachGraphics ( widget:Int, flags:Int )
		Function bbGLGraphicsCreateGraphics ( width:Int, height:Int, depth:Int, hertz:Int, flags:Int )
		Function bbGLGraphicsGetSettings ( context:Int, width:Int Var, height:Int Var, depth:Int Var, hertz:Int Var, flags:Int Var )
		Function bbGLGraphicsClose ( context:Int )	
		Function bbGLGraphicsSetGraphics ( context:Int )
		Function bbGLGraphicsFlip ( sync:Int )
	End Extern

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	INCLUDES
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Include "error.bmx"
Include "TGlClient.bmx"

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
