'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Global	_AVA_GFX_ALPHA_TEST:TByteStack				=	New TByteStack
Global	_AVA_GFX_ALPHA_FUNC:TIntStack				=	New TIntStack
Global	_AVA_GFX_ALPHA_VALUE:TFloatStack				=	New TFloatStack

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SetAlphaTest ( Enabled:Byte )

		If	_AVA_GFX_ALPHA_TEST.get ( ) <> ( Enabled <> False )
			 
			_AVA_GFX_ALPHA_TEST.set ( Enabled <> False )
			_AVA_GFX_UPDATE_ALPHA_TEST ( )

		EndIf
			
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function ResetAlphaTest ( Enabled:Byte )

		_AVA_GFX_ALPHA_TEST.Reset ( Enabled <> False )
		_AVA_GFX_UPDATE_ALPHA_TEST ( )
	
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PushAlphaTest ( Enabled:Byte )
		
		_AVA_GFX_ALPHA_TEST.push ( Enabled <> False )
		_AVA_GFX_UPDATE_ALPHA_TEST ( )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PopAlphaTest ( )
		
		_AVA_GFX_ALPHA_TEST.pop ( )
		_AVA_GFX_UPDATE_ALPHA_TEST ( )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SetAlphaFunc ( func:Int, value:Float )
		
		If	func <> _AVA_GFX_ALPHA_FUNC.Get ( ) Or value <> _AVA_GFX_ALPHA_VALUE.Get ( )
			
			_AVA_GFX_ALPHA_FUNC.Set ( func )
			_AVA_GFX_ALPHA_VALUE.Set ( value )
	
			_AVA_GFX_UPDATE_ALPHA_FUNC ( )
			
		EndIf

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function ResetAlphaFunc ( func:Int, value:Float )

		_AVA_GFX_ALPHA_FUNC.Reset ( func )
		_AVA_GFX_ALPHA_VALUE.Reset ( value )
	
		_AVA_GFX_UPDATE_ALPHA_FUNC ( )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PushAlphaFunc ( func:Int, value:Float )

		_AVA_GFX_ALPHA_FUNC.Push ( func )
		_AVA_GFX_ALPHA_VALUE.Push ( value )

		_AVA_GFX_UPDATE_ALPHA_FUNC ( )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PopAlphaFunc ( )

		_AVA_GFX_ALPHA_FUNC.Pop ( )
		_AVA_GFX_ALPHA_VALUE.Pop ( )

		_AVA_GFX_UPDATE_ALPHA_FUNC ( )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Function	_AVA_GFX_UPDATE_ALPHA_TEST ( )

		StopDraw ( )

		If	_AVA_GFX_ALPHA_TEST.get ( )
		
			_AVA_GL_CLIENT._ENABLE ( GL_ALPHA_TEST )
		
		Else
		
			_AVA_GL_CLIENT._DISABLE ( GL_ALPHA_TEST )
		
		EndIf
		
		CheckGLError ( )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Function	_AVA_GFX_UPDATE_ALPHA_FUNC ( )
		
		StopDraw ( )

		_AVA_GL_CLIENT._ALPHA_FUNC ( _AVA_GFX_ALPHA_FUNC.Get ( ), _AVA_GFX_ALPHA_VALUE.Get ( ) )

		CheckGLError ( )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

