'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Global	_AVA_GFX_ASPECT_X:TFloatStack					=	New TFloatStack
Global	_AVA_GFX_ASPECT_Y:TFloatStack					=	New TFloatStack

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SetAspect ( x:Float, y:Float, relative:Byte = False )
		
		If	relative
			
			x								:*	_AVA_GFX_ASPECT_X.Get ( )
			y								:*	_AVA_GFX_ASPECT_Y.Get ( )
	
		EndIf
		
		_AVA_GFX_ASPECT_X.Set ( x )
		_AVA_GFX_ASPECT_Y.Set ( y )

		_AVA_GFX_TRANSFORM_MODIFIED					:|	_AVA_GFX_TRANSFORM_ASPECT_MODIFIED

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function ResetAspect ( )

		_AVA_GFX_ASPECT_X.Reset ( 1.00 )
		_AVA_GFX_ASPECT_Y.Reset ( 1.00 )
		
		_AVA_GFX_TRANSFORM_MODIFIED					:|	_AVA_GFX_TRANSFORM_ASPECT_MODIFIED

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PushAspect ( x:Float, y:Float, relative:Byte = False )

		If	relative
			
			x								:*	_AVA_GFX_ASPECT_X.Get ( )
			y								:*	_AVA_GFX_ASPECT_Y.Get ( )

		EndIf

		_AVA_GFX_ASPECT_X.Push ( x )
		_AVA_GFX_ASPECT_Y.Push ( y )

		_AVA_GFX_TRANSFORM_MODIFIED					:|	_AVA_GFX_TRANSFORM_ASPECT_MODIFIED

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PopAspect ( )

		_AVA_GFX_ASPECT_X.Pop ( )
		_AVA_GFX_ASPECT_Y.Pop ( )

		_AVA_GFX_TRANSFORM_MODIFIED					:|	_AVA_GFX_TRANSFORM_ASPECT_MODIFIED

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function GetAspect ( x:Float Var, y:Float Var )

		x									=	_AVA_GFX_ASPECT_X.Get ( )
		y									=	_AVA_GFX_ASPECT_Y.Get ( )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function AspectX:Float ( )

		Return ( _AVA_GFX_ASPECT_X.Get ( ) )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function AspectY:Float ( )

		Return ( _AVA_GFX_ASPECT_Y.Get ( ) )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
