'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Global	_AVA_GFX_COLOR2_R:TFloatStack				=	New TFloatStack
Global	_AVA_GFX_COLOR2_G:TFloatStack				=	New TFloatStack
Global	_AVA_GFX_COLOR2_B:TFloatStack				=	New TFloatStack

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SetColor2 ( r:Float, g:Float, b:Float )

		_AVA_GFX_COLOR2_R.Set ( r )
		_AVA_GFX_COLOR2_G.Set ( g )
		_AVA_GFX_COLOR2_B.Set ( b )

		_AVA_GFX_UPDATE_COLOR2 ( )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function ResetColor2 ( )

		_AVA_GFX_COLOR2_R.Reset ( 0.00 )
		_AVA_GFX_COLOR2_G.Reset ( 0.00 )
		_AVA_GFX_COLOR2_B.Reset ( 0.00 )

		_AVA_GFX_UPDATE_COLOR2 ( )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PushColor2 ( r:Float, g:Float, b:Float )

		_AVA_GFX_COLOR2_R.Push ( r )
		_AVA_GFX_COLOR2_G.Push ( g )
		_AVA_GFX_COLOR2_B.Push ( b )

		_AVA_GFX_UPDATE_COLOR2 ( )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PopColor2 ( )

		_AVA_GFX_COLOR2_R.Pop ( )
		_AVA_GFX_COLOR2_G.Pop ( )
		_AVA_GFX_COLOR2_B.Pop ( )

		_AVA_GFX_UPDATE_COLOR2 ( )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function GetColor2 ( r:Float Var, g:Float Var, b:Float Var )

		r									=	_AVA_GFX_COLOR2_R.Get ( )
		g									=	_AVA_GFX_COLOR2_G.Get ( )
		b									=	_AVA_GFX_COLOR2_B.Get ( )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Function	_AVA_GFX_UPDATE_COLOR2 ( )

		Local	r:Float, g:Float, b:Float
		GetColor2 ( r, g, b )
		
		StopDraw ( )
		
		If	r = 0.00 And g = 0.00 And b = 0.00
			
			_AVA_GL_CLIENT._DISABLE ( GL_COLOR_SUM )
		
		Else
		
			_AVA_GL_CLIENT._ENABLE ( GL_COLOR_SUM )
			_AVA_GL_CLIENT._SEC_COLOR ( r, g, b )
		
		EndIf
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
