'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Global	_AVA_GFX_COLOR_OFFSET_R:TFloatStack				=	New TFloatStack
Global	_AVA_GFX_COLOR_OFFSET_G:TFloatStack				=	New TFloatStack
Global	_AVA_GFX_COLOR_OFFSET_B:TFloatStack				=	New TFloatStack
Global	_AVA_GFX_COLOR_OFFSET_A:TFloatStack				=	New TFloatStack
Global	_AVA_GFX_COLOR_OFFSET_USE:Byte				=	False

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SetColorOffset ( r:Float, g:Float, b:Float, a:Float = 1.00, relative:Byte = False )

		If	relative
		
			r								:+	_AVA_GFX_COLOR_OFFSET_R.Get ( )
			g								:+	_AVA_GFX_COLOR_OFFSET_G.Get ( )
			b								:+	_AVA_GFX_COLOR_OFFSET_B.Get ( )
			a								:+	_AVA_GFX_COLOR_OFFSET_A.Get ( )
		
		EndIf

		_AVA_GFX_COLOR_OFFSET_R.Set ( r )
		_AVA_GFX_COLOR_OFFSET_G.Set ( g )
		_AVA_GFX_COLOR_OFFSET_B.Set ( b )
		_AVA_GFX_COLOR_OFFSET_A.Set ( a )
		_AVA_GFX_COLOR_OFFSET_USE					=	( r <> 1.00 Or g <> 1.00 Or b <> 1.00 Or a <> 1.00 )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function ResetColorOffset ( )

		_AVA_GFX_COLOR_OFFSET_R.Reset ( 1.00 )
		_AVA_GFX_COLOR_OFFSET_G.Reset ( 1.00 )
		_AVA_GFX_COLOR_OFFSET_B.Reset ( 1.00 )
		_AVA_GFX_COLOR_OFFSET_A.Reset ( 1.00 )
		_AVA_GFX_COLOR_OFFSET_USE					=	False

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PushColorOffset ( r:Float, g:Float, b:Float, a:Float = 1.00, relative:Byte = False )
		
		If	relative
		
			r								:+	_AVA_GFX_COLOR_OFFSET_R.Get ( )
			g								:+	_AVA_GFX_COLOR_OFFSET_G.Get ( )
			b								:+	_AVA_GFX_COLOR_OFFSET_B.Get ( )
			a								:+	_AVA_GFX_COLOR_OFFSET_A.Get ( )
		
		EndIf
		
		_AVA_GFX_COLOR_OFFSET_R.Push ( r )
		_AVA_GFX_COLOR_OFFSET_G.Push ( g )
		_AVA_GFX_COLOR_OFFSET_B.Push ( b )
		_AVA_GFX_COLOR_OFFSET_A.Push ( a )
		_AVA_GFX_COLOR_OFFSET_USE					=	( r <> 1.00 Or g <> 1.00 Or b <> 1.00 Or a <> 1.00 )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PopColorOffset ( )

		_AVA_GFX_COLOR_OFFSET_R.Pop ( )
		_AVA_GFX_COLOR_OFFSET_G.Pop ( )
		_AVA_GFX_COLOR_OFFSET_B.Pop ( )
		_AVA_GFX_COLOR_OFFSET_A.Pop ( )
		_AVA_GFX_COLOR_OFFSET_USE					=	( _AVA_GFX_COLOR_OFFSET_R.Get ( ) <> 1.00 Or _AVA_GFX_COLOR_OFFSET_G.Get ( ) <> 1.00 Or _AVA_GFX_COLOR_OFFSET_B.Get ( ) <> 1.00 Or _AVA_GFX_COLOR_OFFSET_A.Get ( ) <> 1.00 )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function GetColorOffset ( r:Float Var, g:Float Var, b:Float Var, a:Float Var )

		r									=	_AVA_GFX_COLOR_OFFSET_R.Get ( )
		g									=	_AVA_GFX_COLOR_OFFSET_G.Get ( )
		b									=	_AVA_GFX_COLOR_OFFSET_B.Get ( )
		a									=	_AVA_GFX_COLOR_OFFSET_A.Get ( )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
