'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Global	_AVA_GFX_COLOR_SCALE_R:TFloatStack				=	New TFloatStack
Global	_AVA_GFX_COLOR_SCALE_G:TFloatStack				=	New TFloatStack
Global	_AVA_GFX_COLOR_SCALE_B:TFloatStack				=	New TFloatStack
Global	_AVA_GFX_COLOR_SCALE_A:TFloatStack				=	New TFloatStack
Global	_AVA_GFX_COLOR_SCALE_USE:Byte				=	False

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SetColorScale ( r:Float, g:Float, b:Float, a:Float = 1.00, relative:Byte = False )

		If	relative
		
			r								:*	_AVA_GFX_COLOR_SCALE_R.Get ( )
			g								:*	_AVA_GFX_COLOR_SCALE_G.Get ( )
			b								:*	_AVA_GFX_COLOR_SCALE_B.Get ( )
			a								:*	_AVA_GFX_COLOR_SCALE_A.Get ( )
		
		EndIf

		_AVA_GFX_COLOR_SCALE_R.Set ( r )
		_AVA_GFX_COLOR_SCALE_G.Set ( g )
		_AVA_GFX_COLOR_SCALE_B.Set ( b )
		_AVA_GFX_COLOR_SCALE_A.Set ( a )
		_AVA_GFX_COLOR_SCALE_USE					=	( r <> 1.00 Or g <> 1.00 Or b <> 1.00 Or a <> 1.00 )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function ResetColorScale ( )

		_AVA_GFX_COLOR_SCALE_R.Reset ( 1.00 )
		_AVA_GFX_COLOR_SCALE_G.Reset ( 1.00 )
		_AVA_GFX_COLOR_SCALE_B.Reset ( 1.00 )
		_AVA_GFX_COLOR_SCALE_A.Reset ( 1.00 )
		_AVA_GFX_COLOR_SCALE_USE					=	False

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PushColorScale ( r:Float, g:Float, b:Float, a:Float = 1.00, relative:Byte = False )
		
		If	relative
		
			r								:*	_AVA_GFX_COLOR_SCALE_R.Get ( )
			g								:*	_AVA_GFX_COLOR_SCALE_G.Get ( )
			b								:*	_AVA_GFX_COLOR_SCALE_B.Get ( )
			a								:*	_AVA_GFX_COLOR_SCALE_A.Get ( )
		
		EndIf
		
		_AVA_GFX_COLOR_SCALE_R.Push ( r )
		_AVA_GFX_COLOR_SCALE_G.Push ( g )
		_AVA_GFX_COLOR_SCALE_B.Push ( b )
		_AVA_GFX_COLOR_SCALE_A.Push ( a )
		_AVA_GFX_COLOR_SCALE_USE					=	( r <> 1.00 Or g <> 1.00 Or b <> 1.00 Or a <> 1.00 )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PopColorScale ( )

		_AVA_GFX_COLOR_SCALE_R.Pop ( )
		_AVA_GFX_COLOR_SCALE_G.Pop ( )
		_AVA_GFX_COLOR_SCALE_B.Pop ( )
		_AVA_GFX_COLOR_SCALE_A.Pop ( )
		_AVA_GFX_COLOR_SCALE_USE					=	( _AVA_GFX_COLOR_SCALE_R.Get ( ) <> 1.00 Or _AVA_GFX_COLOR_SCALE_G.Get ( ) <> 1.00 Or _AVA_GFX_COLOR_SCALE_B.Get ( ) <> 1.00 Or _AVA_GFX_COLOR_SCALE_A.Get ( ) <> 1.00 )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function GetColorScale ( r:Float Var, g:Float Var, b:Float Var, a:Float Var )

		r									=	_AVA_GFX_COLOR_SCALE_R.Get ( )
		g									=	_AVA_GFX_COLOR_SCALE_G.Get ( )
		b									=	_AVA_GFX_COLOR_SCALE_B.Get ( )
		a									=	_AVA_GFX_COLOR_SCALE_A.Get ( )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
