'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Const _POLY_X:Int									=	1

Rem
bbdoc:
End Rem
Const _POLY_Y:Int									=	2

Rem
bbdoc:
End Rem
Const _POLY_Z:Int									=	4

Rem
bbdoc:
End Rem
Const _POLY_R:Int									=	8

Rem
bbdoc:
End Rem
Const _POLY_G:Int									=	16

Rem
bbdoc:
End Rem
Const _POLY_B:Int									=	32

Rem
bbdoc:
End Rem
Const _POLY_A:Int									=	64

Rem
bbdoc:
End Rem
Const _POLY_L:Int									=	128

Rem
bbdoc:
End Rem
Const _POLY_U:Int									=	256

Rem
bbdoc:
End Rem
Const _POLY_V:Int									=	512

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Const POLY_XY:Int									=	_POLY_X | _POLY_Y
							
Rem
bbdoc:
End Rem
Const POLY_XYZ:Int								=	POLY_XY | _POLY_Z

Rem
bbdoc:
End Rem
Const POLY_XY_UV:Int								=	POLY_XY | _POLY_U | _POLY_V

Rem
bbdoc:
End Rem
Const POLY_XYZ_UV:Int								=	POLY_XY_UV | _POLY_Z

Rem
bbdoc:
End Rem
Const POLY_XY_RGB:Int								=	POLY_XY | _POLY_R | _POLY_G | _POLY_B
	
Rem
bbdoc:
End Rem
Const POLY_XY_RGBA:Int								=	POLY_XY_RGB | _POLY_A

Rem
bbdoc:
End Rem
Const POLY_XY_L:Int								=	POLY_XY | _POLY_L

Rem
bbdoc:
End Rem
Const POLY_XY_LA:Int								=	POLY_XY_L | _POLY_A

Rem
bbdoc:
End Rem
Const POLY_XYZ_RGB:Int								=	POLY_XY_RGB | _POLY_Z

Rem
bbdoc:
End Rem
Const POLY_XYZ_RGBA:Int							=	POLY_XYZ_RGB | _POLY_A

Rem
bbdoc:
End Rem
Const POLY_XYZ_L:Int								=	POLY_XYZ | _POLY_L

Rem
bbdoc:
End Rem
Const POLY_XYZ_LA:Int								=	POLY_XYZ_L | _POLY_A

Rem
bbdoc:
End Rem
Const POLY_XY_UV_RGB:Int							=	POLY_XY_RGB | _POLY_U | _POLY_V

Rem
bbdoc:
End Rem
Const POLY_XY_UV_RGBA:Int							=	POLY_XY_UV_RGB | _POLY_A

Rem
bbdoc:
End Rem
Const POLY_XY_UV_L:Int								=	POLY_XY_L | _POLY_U | _POLY_V

Rem
bbdoc:
End Rem
Const POLY_XY_UV_LA:Int							=	POLY_XY_UV_L | _POLY_A

Rem
bbdoc:
End Rem
Const POLY_XYZ_UV_RGB:Int							=	POLY_XYZ_RGB | _POLY_U | _POLY_V 

Rem
bbdoc:
End Rem
Const POLY_XYZ_UV_RGBA:Int							=	POLY_XYZ_UV_RGB | _POLY_A 

Rem
bbdoc:
End Rem
Const POLY_XYZ_UV_L:Int							=	POLY_XYZ_L | _POLY_U | _POLY_V 

Rem
bbdoc:
End Rem
Const POLY_XYZ_UV_LA:Int							=	POLY_XYZ_UV_L | _POLY_A

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Type TPoly

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
	
	Global	_obj:TPoly, _drawmode:Int
	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Field		Mode:Int							=	POLY_XY
	Field		VarNum:Int							=	2

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Field		raw_data:Double [ ]
	Field		final_data:Double [ ], use_drawmode:Int [ ]

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Field		Modified:Byte						=	True
	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	Add ( Data:Float [ ] )

			If	Data.Length < VarNum
			
				Error ( "PolyAddVertex : Data:Float [ ] (Lnge=" + Data.Length + ") bentigt " + VarNum + " Eintrge." )
			
			EndIf
			
			For	Local i:Int = 0 Until VarNum
			
				raw_data						:+	[ Double ( Data [ i ] ) ]
			
			Next
			
			Modified:Byte						=	True

	EndMethod
	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	Draw ( _x:Float, _y:Float, _z:Float )
	
			If	Modified
			
				Update ( )
			
			EndIf
			
			Local	i:Int							=	0
			Local	p:Int							=	0
			Local	x:Float						=	0.00
			Local	y:Float						=	0.00
			Local	z:Float						=	0.00
			Local	u:Float						=	0.00
			Local	v:Float						=	0.00
			Local	r:Float						=	1.00
			Local	g:Float						=	1.00
			Local	b:Float						=	1.00
			Local	a:Float						=	1.00
			
			EndDraw ( )
					
			While ( p < Final_Data.Length )
			
				If	Mode & _POLY_X
					
					x						=	Final_Data [ p ]
					p						:+	1
			
				EndIf

				If	Mode & _POLY_Y
					
					y						=	Final_Data [ p ]
					p						:+	1
			
				EndIf
				
				If	Mode & _POLY_Z
					
					z						=	Final_Data [ p ]
					p						:+	1
			
				EndIf

				If	Mode & _POLY_U
					
					u						=	Final_Data [ p ]
					p						:+	1
			
				EndIf

				If	Mode & _POLY_V
					
					v						=	Final_Data [ p ]
					p						:+	1
			
				EndIf

				If	Mode & _POLY_R
					
					r						=	Final_Data [ p ]
					p						:+	1
			
				EndIf

				If	Mode & _POLY_G
					
					g						=	Final_Data [ p ]
					p						:+	1
			
				EndIf

				If	Mode & _POLY_B
					
					b						=	Final_Data [ p ]
					p						:+	1
			
				EndIf

				If	Mode & _POLY_L
					
					r						=	Final_Data [ p ]
					g						=	Final_Data [ p ]
					b						=	Final_Data [ p ]
					p						:+	1
			
				EndIf

				If	Mode & _POLY_A
					
					a						=	Final_Data [ p ]
					p						:+	1
			
				EndIf
			
				If	_AVA_GFX_DRAWMODE <> Use_DrawMode [ i ]
				
					StartDraw ( Use_DrawMode [ i ] )
				
				EndIf
				
				DrawVertex ( _x + x, _y + y, _z + z, u, v, r, g, b, a )
				
				i							:+	1
					
			Wend
			
			EndDraw ( )
			
	EndMethod
	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
	
	Method	Update ( )

			_obj								=	Self
			
			Final_Data							=	Null
			Use_DrawMode						=	Null
		'	Modified							=	False
			
			Local	Tess:Byte Ptr					=	gluNewTess ( )
			Local	p:Int							=	0
	
			gluTessBeginPolygon ( Tess, Null )
		 	gluTessBeginContour ( Tess )

			While ( p < Raw_Data.Length )

				gluTessVertex ( Tess, Varptr Raw_Data [ p ], Varptr Raw_Data [ p ] )	
				
				p							:+	VarNum
				
			Wend
		
       		gluTessCallback ( Tess, GLU_BEGIN, StoreDraw )
		     	gluTessCallback ( Tess, GLU_VERTEX, StoreVertex )
      		gluTessCallback ( Tess, GLU_END, FinishDraw )
      		gluTessCallback ( Tess, GLU_ERROR, OnError )
			
		  	gluTessEndContour ( Tess )
			gluTessEndPolygon ( Tess )
			gluDeleteTess ( Tess )
						
	EndMethod
	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Function	StoreDraw ( Mode:Int )
	
			_drawmode							=	Mode
	
	EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Function	StoreVertex ( p:Double Ptr )

			For	Local i:Int = 0 Until _obj.VarNum
			
				_obj.Final_Data					:+	[ p [ i ] ]
			
			Next
			
			_obj.Use_DrawMode						:+	[ _drawmode ]

	EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Function	FinishDraw ( )
	EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Function	OnError ( Code:Int )
	
			Error ( "DrawPoly : GL_ERROR" ) ' : ~q" + gluErrorString ( Code ) + "~q." )
	
	EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

EndType

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------


Rem
bbdoc:
End Rem
Function CreatePoly:TPoly ( Mode:Int = POLY_XY )

	Local	n:TPoly								=	New TPoly
	
		n.Mode								=	Mode
		n.VarNum								=	0
		
		If	Mode & _POLY_X				n.VarNum	:+	1
		If	Mode & _POLY_Y				n.VarNum	:+	1
		If	Mode & _POLY_Z				n.VarNum	:+	1
		If	Mode & _POLY_U				n.VarNum	:+	1
		If	Mode & _POLY_V				n.VarNum	:+	1
		If	Mode & _POLY_R				n.VarNum	:+	1
		If	Mode & _POLY_G				n.VarNum	:+	1
		If	Mode & _POLY_B				n.VarNum	:+	1
		If	Mode & _POLY_L				n.VarNum	:+	1
		If	Mode & _POLY_A				n.VarNum	:+	1
		
	Return ( n )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------


