'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Global	_AVA_GFX_DRAWMODE:Int						=	-1
Global	_AVA_GFX_DRAWMODE_REM:Int					=	-1

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function StartDraw ( mode:Int )

		Select mode
		
			Case	GL_POINTS, GL_LINES, GL_LINE_STRIP, GL_LINE_LOOP, GL_TRIANGLES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_QUADS, GL_QUAD_STRIP, GL_POLYGON
			Default	Error ( "StartDraw : Modus ( " + mode + " ) ist nicht verfgbar.~n( Verfgbar : GL_POINTS, GL_LINES, GL_LINE_STRIP, GL_LINE_LOOP, GL_TRIANGLES, GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_QUADS, GL_QUAD_STRIP, GL_POLYGON )" )
		
		EndSelect

		If	_AVA_GFX_DRAWMODE <> -1
		
			EndDraw ( )
		
		EndIf

		_AVA_GFX_UPDATE_TEXTURE ( )

		CheckGLError ( )
		glBegin ( mode )
		
		_AVA_GFX_DRAWMODE 						=	mode
		_AVA_GFX_DRAWMODE_REM						=	-1
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function EndDraw ( )
		
		If	_AVA_GFX_DRAWMODE <> -1

			Select _AVA_GFX_DRAWMODE
				
				Case	GL_TRIANGLES
						
					TAvaGraphics._POLY_COUNTER			:+	( TAvaGraphics._TEMP_VERTEX_COUNTER / 3 )
					TAvaGraphics._TRIANGLE_COUNTER		:+	( TAvaGraphics._TEMP_VERTEX_COUNTER / 3 )
				
				Case	GL_QUADS
		
					TAvaGraphics._POLY_COUNTER			:+	( TAvaGraphics._TEMP_VERTEX_COUNTER / 4 )
					TAvaGraphics._TRIANGLE_COUNTER		:+	( TAvaGraphics._TEMP_VERTEX_COUNTER / 2 )

				Case	GL_LINES
		
				'	TAvaGraphics._POLY_COUNTER			:+	1
				'	TAvaGraphics._TRIANGLE_COUNTER		:+	( TAvaGraphics._TEMP_VERTEX_COUNTER - 2, 0 )

				Case	GL_TRIANGLE_STRIP, GL_TRIANGLE_FAN, GL_POLYGON
						
					TAvaGraphics._POLY_COUNTER			:+	1
					TAvaGraphics._TRIANGLE_COUNTER		:+	Max ( TAvaGraphics._TEMP_VERTEX_COUNTER - 2, 0 )
				
				Case	GL_QUAD_STRIP
		
					TAvaGraphics._POLY_COUNTER			:+	1
					TAvaGraphics._TRIANGLE_COUNTER		:+	Max ( TAvaGraphics._TEMP_VERTEX_COUNTER - 2, 0 )
			
				Case	GL_LINE_STRIP
		
				'	TAvaGraphics._POLY_COUNTER			:+	Max ( TAvaGraphics._TEMP_VERTEX_COUNTER - 1, 0 )

				Case	GL_LINE_LOOP
		
				'	TAvaGraphics._POLY_COUNTER			:+	TAvaGraphics._TEMP_VERTEX_COUNTER

				Case	GL_POINTS
		
				'	TAvaGraphics._POLY_COUNTER			:+	TAvaGraphics._TEMP_VERTEX_COUNTER

			EndSelect
			
			TAvaGraphics._VERTEX_COUNTER					:+	TAvaGraphics._TEMP_VERTEX_COUNTER
			TAvaGraphics._TEMP_VERTEX_COUNTER				=	0
			
			glEnd ( )
			CheckGLError ( )
		
			_AVA_GFX_DRAWMODE							=	-1
					
		EndIf
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function ContinueDraw ( )
		
		If	_AVA_GFX_DRAWMODE = -1 And _AVA_GFX_DRAWMODE_REM <> -1

			StartDraw ( _AVA_GFX_DRAWMODE_REM )

		EndIf

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function StopDraw ( )
		
		If	_AVA_GFX_DRAWMODE <> -1
						
			_AVA_GFX_DRAWMODE_REM					=	_AVA_GFX_DRAWMODE 

			EndDraw ( )
		
		EndIf
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function DrawVertex ( x:Float, y:Float, z:Float = 0.00, u:Float = 0.00, v:Float = 0.00, r:Float = 1.00, g:Float = 1.00, b:Float = 1.00, a:Float = 1.00, Transform:Byte = True )
		
		If	_AVA_GFX_DRAWMODE = -1

			ContinueDraw ( )
		
			If	_AVA_GFX_DRAWMODE = -1
			
				Error ( "DrawVertex : Es ist kein Zeichenmodus aktiv." )
			
			EndIf
		
		EndIf
		
		Local	_x:Float, _y:Float, _z:Float, _u:Float, _v:Float, fx:Float, fy:Float, fz:Float
		
		For	Local Unit:Int = 0 Until _AVA_GFX_TEXTURE.length
			
			Select True
			
				Case Unit = 0
					
					If	Transform
			
						_AVA_GFX_TRANSFORM ( x, y, z )
						
						If	_AVA_GFX_TRANSFORM_NO_FRACT
						
							x				=	Int ( x )
							y				=	Int ( y )
					
						EndIf
						
					EndIf

					_x						=	x
					_y						=	y
					_z						=	z
					_u						=	u
					_v						=	v			
					
					fx						=	x
					fy						=	y
					fz						=	z

					_AVA_GFX_PROJECT ( fx, fy, fz, u, v, r, g, b, a, Unit )
					
					_AVA_GFX_COLOR_TRANSFORM ( r, g, b, a )
					_AVA_GFX_UVTRANSFORM ( u, v )
					
					_AVA_GL_CLIENT._COLOR ( r, g, b, a )		
					_AVA_GL_CLIENT._TEXCOORD ( u, v )
				
				'	glMultiTexCoord2f ( GL_TEXTURE0, u, v )
				
				Case	_AVA_GFX_TEXTURE [ Unit ] . Get ( ) <> Null
					
					x						=	_x
					y						=	_y
					u						=	_u
					v						=	_v
					
					_AVA_GFX_PROJECT ( x, y, z, u, v, r, g, b, a, Unit )
					_AVA_GFX_UVTRANSFORM ( u, v )
					
					glMultiTexCoord2f ( GL_TEXTURE0 + Unit, u, v )
				
			EndSelect
							
		Next

		glVertex3f ( fx, fy, fz ) 
		
		TAvaGraphics._TEMP_VERTEX_COUNTER				:+	1
					
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function RenderedVertices:Int ( )

	StopDraw ( )

	Return ( TAvaGraphics._VERTEX_COUNTER )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function RenderedPolys:Int ( )

	StopDraw ( )

	Return ( TAvaGraphics._POLY_COUNTER )

EndFunction
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function RenderedTriangles:Int ( )

	StopDraw ( )

	Return ( TAvaGraphics._TRIANGLE_COUNTER )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
