'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	SETUP
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	RegisterMediaLoader ( New TMediaImageFontLoader, [ "TTF" ] )

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	TYPE
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Type TMediaImageFontLoader Extends TMediaLoader

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	METHODS
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	LoadFile ( Index:Int )
	
			MapInsert ( MediaMap, Handle [ Index ], LoadImageFont ( File [ Index ], FloatValues [ Index ] [ 0 ], Flags [ Index ] ) )
	
	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	FINISHED
'---------------------------------------------------------------------------------------------------------------------------------------------------------

EndType

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	EXTERNAL FUNCTIONS
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function AddMediaImageFont ( Handle:String, File:String, Size:Int, Flags:Int = -1 )

		AddMedia ( Handle, File, Flags, "", [ Float ( Size ) ] )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function GetMediaImageFont:TImageFont ( Handle:String )

		Local	n:TImageFont 						=	TImageFont ( GetMedia ( Handle ) )
		
		If	n = Null
		
			Error ( "GetMediaImageFont : TImageFont ~q" + Handle + "~q existiert nicht." )
		
		EndIf
		
		Return ( n )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

