'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Global	_AVA_GFX_OFFSET_X:TFloatStack				=	New TFloatStack
Global	_AVA_GFX_OFFSET_Y:TFloatStack				=	New TFloatStack
Global	_AVA_GFX_OFFSET_Z:TFloatStack				=	New TFloatStack

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SetOffset ( x:Float, y:Float, z:Float = 0.00, relative:Byte = False )

		If	relative
			
			x								:+	_AVA_GFX_OFFSET_X.Get ( )
			y								:+	_AVA_GFX_OFFSET_Y.Get ( )
			z								:+	_AVA_GFX_OFFSET_Z.Get ( )
		
		EndIf

		_AVA_GFX_OFFSET_X.Set ( x )
		_AVA_GFX_OFFSET_Y.Set ( y )
		_AVA_GFX_OFFSET_Z.Set ( z )

		_AVA_GFX_TRANSFORM_MODIFIED					:|	_AVA_GFX_TRANSFORM_OFFSET_MODIFIED

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function ResetOffset ( )

		_AVA_GFX_OFFSET_X.Reset ( 0.00 )
		_AVA_GFX_OFFSET_Y.Reset ( 0.00 )
		_AVA_GFX_OFFSET_Z.Reset ( 0.00 )
		
		_AVA_GFX_TRANSFORM_MODIFIED					:|	_AVA_GFX_TRANSFORM_OFFSET_MODIFIED

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PushOffset ( x:Float, y:Float, z:Float = 0.00, relative:Byte = False )

		If	relative
			
			x								:+	_AVA_GFX_OFFSET_X.Get ( )
			y								:+	_AVA_GFX_OFFSET_Y.Get ( )
			z								:+	_AVA_GFX_OFFSET_Z.Get ( )
		
		EndIf

		_AVA_GFX_OFFSET_X.Push ( x )
		_AVA_GFX_OFFSET_Y.Push ( y )
		_AVA_GFX_OFFSET_Z.Push ( z )

		_AVA_GFX_TRANSFORM_MODIFIED					:|	_AVA_GFX_TRANSFORM_OFFSET_MODIFIED

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PopOffset ( )

		_AVA_GFX_OFFSET_X.Pop ( )
		_AVA_GFX_OFFSET_Y.Pop ( )
		_AVA_GFX_OFFSET_Z.Pop ( )

		_AVA_GFX_TRANSFORM_MODIFIED					:|	_AVA_GFX_TRANSFORM_OFFSET_MODIFIED

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

