'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	SETUP
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	RegisterMediaLoader ( New TMediaShaderLoader, [ "[SHADER]" ] )

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	TYPE
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Type TMediaShaderLoader Extends TMediaLoader

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	METHODS
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	LoadFile ( Index:Int )
	
			MapInsert ( MediaMap, Handle [ Index ], LoadShader ( File [ Index ], Tag [ Index ], Flags [ Index ] ) )
	
	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	FINISHED
'---------------------------------------------------------------------------------------------------------------------------------------------------------

EndType

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	EXTERNAL FUNCTIONS
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function AddMediaShader ( Handle:String, VertexFile:String, FragmentFile:String, Flags:Int = -1 )

		AddMedia ( Handle, VertexFile, Flags, FragmentFile, Null )

		TMediaLoader.Ext [ TMediaLoader.Ext.Length - 1 ]	=	"[SHADER]"

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function GetMediaShader:TShader ( Handle:String )
		
		Local	n:TShader 							=	TShader ( GetMedia ( Handle ) )
		
		If	n = Null
		
			Error ( "GetMediaShader : TShader ~q" + Handle + "~q existiert nicht." )
		
		EndIf
		
		Return ( n )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

