'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Global	_AVA_GFX_UVORIGIN_X:TFloatStack				=	New TFloatStack
Global	_AVA_GFX_UVORIGIN_Y:TFloatStack				=	New TFloatStack

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SetUVOrigin ( x:Float, y:Float, relative:Byte = False )

		If	relative
			
			x								:+	_AVA_GFX_UVORIGIN_X.Get ( )
			y								:+	_AVA_GFX_UVORIGIN_Y.Get ( )
	
		EndIf
		
		_AVA_GFX_UVORIGIN_X.Set ( x )
		_AVA_GFX_UVORIGIN_Y.Set ( y )
		
		_AVA_GFX_UVTRANSFORM_MODIFIED				:|	_AVA_GFX_UVTRANSFORM_UVORIGIN_MODIFIED

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function ResetUVOrigin ( )

		_AVA_GFX_UVORIGIN_X.Reset ( 0.00 )
		_AVA_GFX_UVORIGIN_Y.Reset ( 0.00 )
		
		_AVA_GFX_UVTRANSFORM_MODIFIED				:|	_AVA_GFX_UVTRANSFORM_UVORIGIN_MODIFIED

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PushUVOrigin ( x:Float, y:Float, relative:Byte = False )

		If	relative
			
			x								:+	_AVA_GFX_UVORIGIN_X.Get ( )
			y								:+	_AVA_GFX_UVORIGIN_Y.Get ( )
		
		EndIf

		_AVA_GFX_UVORIGIN_X.Push ( x )
		_AVA_GFX_UVORIGIN_Y.Push ( y )

		_AVA_GFX_UVTRANSFORM_MODIFIED				:|	_AVA_GFX_UVTRANSFORM_UVORIGIN_MODIFIED

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PopUVOrigin ( )

		_AVA_GFX_UVORIGIN_X.Pop ( )
		_AVA_GFX_UVORIGIN_Y.Pop ( )

		_AVA_GFX_UVTRANSFORM_MODIFIED				:|	_AVA_GFX_UVTRANSFORM_UVORIGIN_MODIFIED

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

