'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Global	_AVA_GFX_UVROTATION:TFloatStack				=	New TFloatStack
Global	_AVA_GFX_UVROTATION_COS:TFloatStack			=	New TFloatStack
Global	_AVA_GFX_UVROTATION_SIN:TFloatStack			=	New TFloatStack

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SetUVRotation ( a:Float, relative:Byte = False )

		If	relative
			
			a								:+	_AVA_GFX_UVROTATION.Get ( )
	
		EndIf
		
		If	a <> _AVA_GFX_UVROTATION.Get ( )
		
			_AVA_GFX_UVROTATION.Set ( a )
			_AVA_GFX_UVROTATION_COS.Set ( Cos ( a ) )
			_AVA_GFX_UVROTATION_SIN.Set ( Sin ( a ) )		

			_AVA_GFX_UVTRANSFORM_MODIFIED			:|	_AVA_GFX_UVTRANSFORM_UVROTATION_MODIFIED
		
		EndIf
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function ResetUVRotation( )

		_AVA_GFX_UVROTATION.Set ( 0.00 )
		_AVA_GFX_UVROTATION_COS.Set ( 1.00 )
		_AVA_GFX_UVROTATION_SIN.Set ( 0.00 )		

		_AVA_GFX_UVTRANSFORM_MODIFIED				:|	_AVA_GFX_UVTRANSFORM_UVROTATION_MODIFIED
			
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PushUVRotation ( a:Float, relative:Byte = False )

		If	relative
			
			a								:+	_AVA_GFX_UVROTATION.Get ( )
	
		EndIf

		_AVA_GFX_UVROTATION.Push ( a )
		_AVA_GFX_UVROTATION_COS.Push ( Cos ( a ) )
		_AVA_GFX_UVROTATION_SIN.Push ( Sin ( a ) )		

		_AVA_GFX_UVTRANSFORM_MODIFIED				:|	_AVA_GFX_UVTRANSFORM_UVROTATION_MODIFIED
	
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PopUVRotation ( )

		_AVA_GFX_UVROTATION.Pop ( )
		_AVA_GFX_UVROTATION_COS.Pop ( )
		_AVA_GFX_UVROTATION_SIN.Pop ( )	

		_AVA_GFX_UVTRANSFORM_MODIFIED				:|	_AVA_GFX_UVTRANSFORM_UVROTATION_MODIFIED
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

