'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Global	_AVA_GFX_UVSCALE_X:TFloatStack					=	New TFloatStack
Global	_AVA_GFX_UVSCALE_Y:TFloatStack					=	New TFloatStack

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SetUVScale ( x:Float, y:Float, relative:Byte = False )
		
		If	relative
			
			x								:*	_AVA_GFX_UVSCALE_X.Get ( )
			y								:*	_AVA_GFX_UVSCALE_Y.Get ( )
		
		EndIf
		
		_AVA_GFX_UVSCALE_X.Set ( x )
		_AVA_GFX_UVSCALE_Y.Set ( y )

		_AVA_GFX_UVTRANSFORM_MODIFIED					:|	_AVA_GFX_UVTRANSFORM_UVSCALE_MODIFIED

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function ResetUVScale ( )

		_AVA_GFX_UVSCALE_X.Reset ( 1.00 )
		_AVA_GFX_UVSCALE_Y.Reset ( 1.00 )
		
		_AVA_GFX_UVTRANSFORM_MODIFIED					:|	_AVA_GFX_UVTRANSFORM_UVSCALE_MODIFIED

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PushUVScale ( x:Float, y:Float, relative:Byte = False )

		If	relative
			
			x								:*	_AVA_GFX_UVSCALE_X.Get ( )
			y								:*	_AVA_GFX_UVSCALE_Y.Get ( )
		
		EndIf

		_AVA_GFX_UVSCALE_X.Push ( x )
		_AVA_GFX_UVSCALE_Y.Push ( y )

		_AVA_GFX_UVTRANSFORM_MODIFIED					:|	_AVA_GFX_UVTRANSFORM_UVSCALE_MODIFIED

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PopUVScale ( )

		_AVA_GFX_UVSCALE_X.Pop ( )
		_AVA_GFX_UVSCALE_Y.Pop ( )

		_AVA_GFX_UVTRANSFORM_MODIFIED					:|	_AVA_GFX_UVTRANSFORM_UVSCALE_MODIFIED

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
