'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Global _AVA_SIMPLE_PICKED_OBJECT:Object
Global _AVA_SIMPLE_PICKED_INDEX:Int
Global _AVA_SIMPLE_PICKED_X:Int
Global _AVA_SIMPLE_PICKED_Y:Int
Global _AVA_SIMPLE_PICKED_XP:Double
Global _AVA_SIMPLE_PICKED_YP:Double

Global _AVA_SIMPLE_PICK_STACK:TByteStack				=	New TByteStack

Global _AVA_SIMPLE_DRAG_OBJECT:Object
Global _AVA_SIMPLE_DRAG_INDEX:Int

'---------------------------------------------------------------------------------------------------------------------------------------------------------

_AVA_SIMPLE_PICK_STACK.Reset ( True )

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function DragSimplePick ( )
	
	_AVA_SIMPLE_DRAG_OBJECT						=	_AVA_SIMPLE_PICKED_OBJECT
	_AVA_SIMPLE_DRAG_INDEX							=	_AVA_SIMPLE_PICKED_INDEX
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SetSimpleDragObject ( Obj:Object, Index:Int = 0 )
	
	_AVA_SIMPLE_DRAG_OBJECT						=	Obj
	_AVA_SIMPLE_DRAG_INDEX							=	Index
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function ClearSimpleDrag ( )
	
	_AVA_SIMPLE_DRAG_OBJECT						=	Null
	_AVA_SIMPLE_DRAG_INDEX							=	0
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SimpleDragObject:Object ( )
	
	Return ( _AVA_SIMPLE_DRAG_OBJECT )
	
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SimpleDragIndex:Int ( )
	
	Return ( _AVA_SIMPLE_DRAG_INDEX )
	
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function CheckSimpleDrag:Byte ( Obj:Object, Index:Int = 0, CheckIndex:Byte = True )
	
	Return ( _AVA_SIMPLE_DRAG_OBJECT = Obj Or ( String ( Obj ) <> "" And String ( Obj ) = String ( _AVA_SIMPLE_DRAG_OBJECT ) ) And ( CheckIndex = False Or _AVA_SIMPLE_DRAG_INDEX = Index ) )
	
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function CheckSimplePick:Byte ( Obj:Object, Index:Int = 0, CheckIndex:Byte = True )
	
	Return ( _AVA_SIMPLE_PICKED_OBJECT = Obj Or ( String ( Obj ) <> "" And String ( Obj ) = String ( _AVA_SIMPLE_PICKED_OBJECT ) ) And ( CheckIndex = False Or _AVA_SIMPLE_PICKED_INDEX = Index ) )
	
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function GetSimplePickMode:Byte ( )
	
	Return ( _AVA_SIMPLE_PICK_STACK.Get ( ) )
	
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SetSimplePickMode ( Enabled:Byte )
	
	_AVA_SIMPLE_PICK_STACK.Set ( Enabled )
	
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PushSimplePickMode ( Enabled:Byte )
	
	_AVA_SIMPLE_PICK_STACK.Push ( Enabled )
	
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PopSimplePickMode ( )
	
	_AVA_SIMPLE_PICK_STACK.Pop ( )
	
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function ClearSimplePick ( )
	
	_AVA_SIMPLE_PICKED_OBJECT						=	Null
	_AVA_SIMPLE_PICKED_INDEX						=	0
	
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SimplePickedObject:Object ( )
	
	Return ( _AVA_SIMPLE_PICKED_OBJECT )
	
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SimplePickedIndex:Int ( )
	
	Return ( _AVA_SIMPLE_PICKED_INDEX )
	
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SimplePickedX:Float ( )
	
	Return ( _AVA_SIMPLE_PICKED_X )
	
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SimplePickedY:Float ( )
	
	Return ( _AVA_SIMPLE_PICKED_Y )
	
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SimplePickedXP:Double ( )
	
	Return ( _AVA_SIMPLE_PICKED_XP )
	
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SimplePickedYP:Double ( )
	
	Return ( _AVA_SIMPLE_PICKED_YP )
	
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SimpleRectPick:Byte ( Obj:Object, x:Float, y:Float, Width:Float, Height:Float, Index:Int = 0 )
	
	If	GetSimplePickMode ( )
	
		Local	mx:Float							=	GetMouseX ( )
		Local	my:Float							=	GetMouseY ( )
		
		InvTransform2D ( mx, my )
		
		If	PointInViewport ( GetMouseX ( ), GetMouseY ( ) ) And PointInRect ( mx, my, x, y, Width, Height )
					
			_AVA_SIMPLE_PICKED_OBJECT				=	Obj
			_AVA_SIMPLE_PICKED_INDEX				=	Index
			_AVA_SIMPLE_PICKED_X					=	mx - x
			_AVA_SIMPLE_PICKED_Y					=	my - y
			_AVA_SIMPLE_PICKED_XP					=	_AVA_SIMPLE_PICKED_X / Double ( Width )
			_AVA_SIMPLE_PICKED_YP					=	_AVA_SIMPLE_PICKED_Y / Double (  Height )
			
			Return ( True )
			
		Else
		
			If	CheckSimplePick ( Obj, Index )

				ClearSimplePick ( )
			
			EndIf
			
			Return ( False )		
		
		EndIf
		
	EndIf

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SimpleRadialPick:Byte ( Obj:Object, x:Float, y:Float, Length:Float, Index:Int = 0 )

	If	GetSimplePickMode ( )

		Local	mx:Float							=	GetMouseX ( )
		Local	my:Float							=	GetMouseY ( )
		
		InvTransform2D ( mx, my )
		
		If	PointInViewport ( GetMouseX ( ), GetMouseY ( ) ) And LineLength ( mx, my, x, y ) <= Length
		
			_AVA_SIMPLE_PICKED_OBJECT				=	Obj
			_AVA_SIMPLE_PICKED_INDEX				=	Index
			_AVA_SIMPLE_PICKED_X					=	mx - x
			_AVA_SIMPLE_PICKED_Y					=	my - y
			_AVA_SIMPLE_PICKED_XP					=	_AVA_SIMPLE_PICKED_X / Double ( Length )
			_AVA_SIMPLE_PICKED_YP					=	_AVA_SIMPLE_PICKED_Y / Double ( Length )
			
			Return ( True )
			
		Else
		
			If	CheckSimplePick ( Obj, Index )
			
				ClearSimplePick ( )
			
			EndIf
			
			Return ( False )		
		
		EndIf
	
	EndIf

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

